//Mit diesem Programm kann man die Verschlsselten *.csv Dateien vom Airline Tycoon
//Data Ordner entschlsseln und bearbeiten.
//Airline Tycoon kann die entschlsselten Dateien direckt verarbeiten.
//
//Erstellt von: Alexander Bayer - Honk5000
//Fertiggestellt am: 12.04.2011
//Fehler behoben am: 30.07.2012

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.FileOutputStream;
import java.io.File;

import java.io.IOException;
import java.io.FileNotFoundException;


public class Konvertieren
{
	public static void main(String[] args) throws IOException, FileNotFoundException
	{
		try
		{
			if(args.length < 2)
			{
				System.out.println("Richtige Benutzung:\njava Konvertieren Input-Datei Output-Datei");
				System.exit(1);
			}
			
			FileInputStream in = new FileInputStream(new File(args[0]));
			FileOutputStream out = new FileOutputStream(new File(args[1]));
			
			//Die ersten 15 Zeichen lschen
			for (int i = 0; i < 15; i++)
			{
				in.read();
			}
			
			int counter = 0;	//128 Zeichen nach dem letzten doppelbuchstaben steht ein zu entfernendes Zeichen.
			
			int read = in.read();
			int readNext = in.read();
			int readNext2 = in.read();
			int readNext3 = in.read();
			
			while(read != -1){

				counter ++; 
				
				switch(read)
				{
					// Grobuchstaben
					case 228:
						read = 'A'; break;
					case 231:
						read = 'B'; break;
					case 230:
						read = 'C'; break;
					case 225:
						read = 'D'; break;
					case 224:
						read = 'E'; break;
					case 227:
						read = 'F'; break;
					case 226:
						read = 'G'; break;
					case 237:
						read = 'H'; break;
					case 236:
						read = 'I'; break;
					case 239:
						read = 'J'; break;
					case 238:
						read = 'K'; break;
					case 233:
						read = 'L'; break;
					case 232:
						read = 'M'; break;
					case 235:
						read = 'N'; break;
					case 234:
						read = 'O'; break;
					case 245:
						read = 'P'; break;
					case 244:
						read = 'Q'; break;
					case 247:
						read = 'R'; break;
					case 246:
						read = 'S'; break;
					case 241:
						read = 'T'; break;
					case 240:
						read = 'U'; break;
					case 243:
						read = 'V'; break;
					case 242:
						read = 'W'; break;
					case 253:
						read = 'X'; break;
					case '':	// wahrscheinlich
						read = 'Y'; break;
					case 255:
						read = 'Z'; break;
						
					
					// Kleinbuchstaben
					case 196:
						read = 'a'; break;
					case 199:
						read = 'b'; break;
					case 198:
						read = 'c'; break;
					case 193:
						read = 'd'; break;
					case 192:
						read = 'e'; break;
					case 195:
						read = 'f'; break;
					case 194:
						read = 'g'; break;
					case 205:
						read = 'h'; break;
					case 204:
						read = 'i'; break;
					case '':	//wahrscheinlich
						read = 'j'; break;
					case 206:
						read = 'k'; break;
					case 201:
						read = 'l'; break;
					case 200:
						read = 'm'; break;
					case 203:
						read = 'n'; break;
					case 202:
						read = 'o'; break;
					case 213:
						read = 'p'; break;
					case 212:
						read = 'q'; break;
					case 215:
						read = 'r'; break;
					case 214:
						read = 's'; break;
					case 209:
						read = 't'; break;
					case 208:
						read = 'u'; break;
					case 211:
						read = 'v'; break;
					case 210:
						read = 'w'; break;
					case 221:
						read = 'x'; break;
					case 220:
						read = 'y'; break;
					case 223:
						read = 'z'; break;
						
					
					//Zahlen
					case 149:
						read = '0'; break;
					case 148:
						read = '1'; break;
					case 151:
						read = '2'; break;
					case 150:
						read = '3'; break;
					case 145:
						read = '4'; break;
					case 144:
						read = '5'; break;
					case 147:
						read = '6'; break;
					case 146:
						read = '7'; break;
					case 157:
						read = '8'; break;
					case 156:
						read = '9'; break;
						
					
					case 133:
						read = ' '; break;
					case 136:
						read = '-'; break;
					case 142:
						read = '+'; break;
					case 83:
						read = ''; break;
					case 89:
						read = ''; break;
					case 65:
						read = ''; break;
					case 122:
						read = ''; break;
						
					case 121:
						read = ''; break;
						
					case 158:
						read = ';'; break;
					case 159:
						read = ':'; break;
					case 139:
						read = '.'; break;
					case 137:
						read = ','; break;
					case 132:
						read = '!'; break;
					case 154:
						read = '?'; break;
					case 222:
						read = '{'; break;
					case 216:
						read = '}'; break;
					case 141:
						read = '('; break;
					case 140:
						read = ')'; break;
					case 130:
						read = '\''; break;	// '
					case 17:
						read = '\''; break;	// '
					case 135:
						read = '"'; break;
					case 250:
						read = '_'; break;
					case 138:
						read = '/'; break;
					case 131:
						read = '&'; break;
					
						
					case 168:	//Zeilenumbruch
						if(readNext == 175)
						{
							read = 13;
							out.write(read);
							read = 10;
							readNext = readNext2;
							readNext2 = readNext3;
							readNext3 = in.read();
							counter++;
							break;
						}
						else if(readNext2 == 175)
						{	//Zeilenumbruch mit dazwischen einem zu entfernenden Zeichen
							read = 13;
							out.write(read);
							read = 10;
							readNext = readNext3;
							readNext2 = in.read();
							readNext3 = in.read();
							
							counter = 1;
							break;
						}
						/*else
						{	//Zeilenumbruch gekennzeichnet mit nur einem Zeichen
							read = 13;
							out.write(read);
							read = 10;
							break;
						}*/
					case 2:		//ein Zeichen kommt doppelt vor
						if(readNext2 == 2)	//Zwei doppelte Hintereinander
						{			//Form: 2, Zeichen1, 2, Zeichen2, iregendein Zeichen,
							read = readNext;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = 0;
							break;
						}
						else if(readNext2 == 3)	//ein Doppelter und 3 mal das gleiche Zeichen
						{			//Form: 2, Zeichen1, 3, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -3; //-1;
							break;
						}
						else if(readNext2 == 4)	//ein Doppelter und 4 mal das gleiche Zeichen
						{			//Form: 2, Zeichen1, 4, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							out.write(read);
							read = readNext3;
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -2;
							break;
						}
						else if(readNext2 == 5)	//ein Doppelter und 5 mal das gleiche Zeichen
						{			//Form: 2, Zeichen1, 5, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							out.write(read);
							read = readNext3;
							out.write(read);
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -3;
							break;
						}
						else if(readNext2 == 6)	//ein Doppelter und 6 mal das gleiche Zeichen
						{			//Form: 2, Zeichen1, 6, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							out.write(read);
							read = readNext3;
							out.write(read);
							out.write(read);
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -4;
							break;
						}
						//ein doppeltes Zeichen
						//Form: 2, Zeichen, irgendein Zeichen,
						read = readNext;
						readNext = readNext3;
						readNext2 = in.read();
						readNext3 = in.read();
						out.write(read);
						
						counter = 0;
						break;
						
					case 3:		//ein Zeichen kommt 3 mal vor
							//Format: 3, Zeichen, irgendein Zeichen
						if(readNext2 == 2)	//3 mal das gleiche und ein Doppelter
						{			//Form: 3, Zeichen1, 2, Zeichen2, iregendein Zeichen,
							read = readNext;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = 0;
							break;
						}
						else if(readNext2 == 3)	//zweimal hintereinander 3 mal das gleiche Zeichen
						{			//Form: 3, Zeichen1, 3, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -3; //-1;
							break;
						}
						else if(readNext2 == 4)	//3 mal das gleiche und 4 mal das gleiche Zeichen
						{			//Form: 3, Zeichen1, 4, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							out.write(read);
							read = readNext3;
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -2;
							break;
						}
						else if(readNext2 == 5)	//3 mal das gleiche und 5 mal das gleiche Zeichen
						{			//Form: 3, Zeichen1, 5, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							out.write(read);
							read = readNext3;
							out.write(read);
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -3;
							break;
						}
						else if(readNext2 == 6)	//3 mal das gleiche und 6 mal das gleiche Zeichen
						{			//Form: 3, Zeichen1, 6, Zeichen2, iregendein Zeichen,
							read = readNext;
							out.write(read);
							out.write(read);
							read = readNext3;
							out.write(read);
							out.write(read);
							readNext = readNext3;
							readNext2 = readNext3;
							readNext3 = in.read();
							readNext3 = readNext2;
							
							counter = -4;
							break;
						}
						read = readNext;
						readNext2 = readNext;
						
						counter = -2;
						break;
						
					case 4:		//ein Zeichen kommt 4 mal vor
							//Format: 4, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						
						counter = -2;
						break;
					
					case 5:		//ein Zeichen kommt 5 mal vor
							//Format: 5, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						out.write(read);
						
						counter = -2;
						break;
							
					case 6:		//ein Zeichen kommt 6 mal vor
							//Format: 6, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						out.write(read);
						out.write(read);
						
						counter = -2;
						break;
					
					case 7:		//ein Zeichen kommt 7 mal vor
							//Format: 7, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						
						counter = -2;
						break;
						
					case 8:		//ein Zeichen kommt 8 mal vor
							//Format: 8, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						
						counter = -2;
						break;
					
					case 9:		//ein Zeichen kommt 9 mal vor
							//Format: 9, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						
						counter = -2;
						break;
						
					case 10:	//ein Zeichen kommt 10 mal vor
							//Format: 10, Zeichen, irgendein Zeichen
						read = readNext;
						readNext2 = readNext;
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						out.write(read);
						
						counter = -2;
						break;
				}
				
				if(counter != 128)
				{
					out.write(read);
				}
				if(counter == 128)
				{
					counter = 0;
				}
				
				read = readNext;
				readNext = readNext2;
				readNext2 = readNext3;
				readNext3 = in.read();
			}
			
			out.flush();
			out.close();
			
		}
		catch(FileNotFoundException e)
		{
			System.out.println("Die Datei: "+args[0]+" existiert nicht.");
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
